#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair 
#define pb push_back 

#include <iostream>
#include <algorithm>
#include <math.h>
#include <stack>
#include <vector>
#include <queue>
#include <iomanip>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll maxn = 2e5 + 1;
const ll alp = 30;
const ll inf = 1e9 + 10;
const ll mod = 1e9 + 7;


ld sqr(ld a) //  
{
	return a * a;
}


bool ldEqual(ld a, ld b) //     eps,  1-9   
{
	return fabs(a - b) < 1e-9;
}


bool ldLessOrEqual(ld a, ld b) // <=  eps
{
	return a < b || ldEqual(a, b);
}


bool ldLess(ld a, ld b) // <  eps
{
	return a < b && !ldEqual(a, b);
}


bool ldGreaterOrEqual(ld a, ld b) // >=  eps
{
	return a > b || ldEqual(a, b);
}


bool ldGreater(ld a, ld b) // >  eps
{
	return a > b && !ldEqual(a, b);
}


ld mySqrt(ld a) // mySqrt  ,   
{
	if (ldLess(a, 0)) // 
	{
		throw "sqrt(-1)";
	}
	if (a < 0) return 0; //   
	return sqrt(a);
}



struct Point { //    ,       
				//   (  )     (A, B, C, D, ...)
				//  - (v, u, w,...)
private: ld x, y; // 2  ,   
public:
	Point() : x(0), y(0) {} //   

	Point(ld x, ld y) : x(x), y(y) {} //      Point(x = 0...)
											//      Point A = 2;

	void scan() //   
	{
		scanf("%lf %lf", &x, &y);
	}

	void print() const //   
	{
		printf("%.10lf %.10lf\n", x, y);
	}

	bool operator==(const Point& p) const {
		if (ldEqual(p.x, this->x) && ldEqual(p.y, this->y))
			return true;
		return false;
	}
	Point operator+(const Point& p) const //  2 
	{
		return Point(x + p.x, y + p.y);
	}

	Point operator-(const Point& p) const //  2 
	{
		return Point(x - p.x, y - p.y);
	}

	Point operator-() const //  
	{
		return Point(-x, -y);
	}

	Point operator*(ld k) const //    
	{
		return Point(x * k, y * k);
	}

	Point operator/(ld k) const //    
	{
		return Point(x / k, y / k);
	}

	ld operator%(const Point& p) const //  
	{
		return x * p.x + y * p.y;
	}

	ld operator*(const Point& p) const //  
	{
		return x * p.y - y * p.x;
	}

	ld length() const //      . (   )
	{
		return mySqrt(*this % *this);
	}

	ld distTo(const Point& p) const //  2  -    
	{
		return (*this - p).length();
	}

	ld distTo(const Point& A, const Point& B) const //      ( >= 0)
	{
		ld d = A.distTo(B);
		if (ldEqual(d, 0)) //    ! 
		{
			throw "A = B";
		}
		ld s = (*this - A) * (*this - B); //   
		return fabs(s) / d; //  
	}

	Point normalize(ld k = 1) const //     k
	{
		ld len = length(); //  
		if (ldEqual(len, 0)) //   
		{
			if (ldEqual(k, 0))
			{
				return Point();
			}
			throw "zero-size vector"; //     
		}
		return *this * (k / len);
	}

	Point getH(const Point& A, const Point& B) const //       (A, B)
	{
		Point C = *this;
		Point v = B - A; //   
		Point u = C - A; // ,    
		ld k = v % u / v.length(); //   
		v = v.normalize(k); //   u  v
		Point H = A + v; //   A     u,   A
		return H;
	}

	Point rotate() const //   90     ( )
	{
		return Point(-y, x);
	}

	Point rotate(ld alpha) const //    alpha   
									// (  ,  alpha < 0)
	{
		return rotate(cos(alpha), sin(alpha)); //     
	}

	Point rotate(ld cosa, ld sina) const //      
	{
		Point v = *this;
		Point u = v.rotate(); // ,  v,  (v, u) - ,     
		Point w = v * cosa + u * sina; //     (v, u),  w
		return w;
	}

	bool isZero() const //   ,        
	{
		return ldEqual(x, 0) && ldEqual(y, 0);
	}

	bool isOnLine(const Point& A, const Point& B) const //   ?
	{
		return ldEqual((A - *this) * (B - *this), 0);
	}

	bool isInSegment(const Point& A, const Point& B) const //   ?
	{
		return isOnLine(A, B) && ldLessOrEqual((A - *this) % (B - *this), 0);
	}

	bool isInSegmentStrictly(const Point& A, const Point& B) const //    ?
	{
		return isOnLine(A, B) && ldLess((A - *this) % (B - *this), 0);
	}

	ld getAngle() const
	{
		return atan2(y, x); //      
	}

	ld getAngle(Point u) const
	{
		Point v = *this;
		return atan2(v * u, v % u); //    
	}

};

int getIntersection //    (A, B)   (C, D)
(
	const Point& A,
	const Point& B,
	const Point& C,
	const Point& D,
	Point& O
)
{
	Point v = B - A; //    (A, B)
	ld s1 = (C - A) * (D - A); //   A, C, D
	ld s2 = (D - B) * (C - B); //   B, D, C
	ld s = s1 + s2; //  
	if (ldEqual(s, 0)) //   ( )
	{
		if (!A.isOnLine(C, D)) //  
		{
			return 0; //  
		}
		return 2; //  1   
	}
	v = v / s;
	v = v * s1; //  AO  AB   s1  s
	O = A + v; //   
	return 1; // 1   
}

bool has_inter(Point A, Point B, Point C, Point D) {

	Point Res;
	if (getIntersection(A, B, C, D, Res) == 2) {
		return true;
	}
	if (getIntersection(A, B, C, D, Res) == 0) {
		return false;
	}
	
	if (Res.isInSegmentStrictly(A, B)) {
		if (Res.isInSegmentStrictly(C, D)) {
			return true;
		}
	}
	return false;
}

struct pt {
	ld x, y;
};

bool cmp(pt a, pt b) {
	return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw(pt a, pt b, pt c) {
	return a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) < 0;
}
bool ccw(pt a, pt b, pt c) {
	return a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) > 0;
}
void convex_hull(vector<pt>& a) {
	if (a.size() == 1) return;
	sort(a.begin(), a.end(), &cmp);
	pt p1 = a[0], p2 = a.back();
	vector<pt> up, down;
	up.push_back(p1);
	down.push_back(p1);
	for (size_t i = 1; i < a.size(); ++i) {
		if (i == a.size() - 1 || cw(p1, a[i], p2)) {
			while (up.size() >= 2 && !cw(up[up.size() - 2], up[up.
				size() - 1], a[i]))
				up.pop_back();
			up.push_back(a[i]);
		}
		if (i == a.size() - 1 || ccw(p1, a[i], p2)) {
			while (down.size() >= 2 && !ccw(down[down.size() - 2],
				down[down.size() - 1], a[i]))
				down.pop_back();
			down.push_back(a[i]);
		}
	}
	a.clear();
	for (size_t i = 0; i < up.size(); ++i)
		a.push_back(up[i]);
	for (size_t i = down.size() - 2; i > 0; --i)
		a.push_back(down[i]);
}

vector < pt > a, p;

vector < pair < int, int > > b;

vector < pair < Point, Point > > c;

bool used[310][310];

int main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen("notepad.in", "r", stdin);
	//freopen("notepad.out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	for (int i = 1; i <= n; ++i) {
		ld x, y;
		cin >> x >> y;
		p.push_back({ x, y });
		a.push_back({ x, y });
	}

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			b.push_back({ i, j });
		}
	}

	convex_hull(a);

	if (((int)p.size() - (int)a.size()) % 2 == 0) {
		cout << 1 << endl;
		cout << 1 << ' ' << 2;
		int f = 0, s = 1;
		c.push_back(make_pair(Point{ p[f].x, p[f].y }, Point{ p[s].x, p[s].y }));
		used[0][1] = true;
		//b.erase(b.begin());
	}
	else {
		cout << 2;
		
	}
	
	cout << endl;

	int uk = (int)b.size() - 1;

	while (true) {
		int f, s;
		cin >> f >> s;
		if (f == 0 && s == 0) {
			return 0;
		}
		--f, --s;
		if (f > s)
			swap(f, s);
		c.push_back(make_pair(Point{ p[f].x, p[f].y }, Point{ p[s].x, p[s].y }));
		while (uk >= 0) {
			bool ok1 = true;
			if (used[b[uk].first][b[uk].second]) {
				--uk;
				continue;
			}
			for (int i = 0; i < c.size(); ++i) {
				Point fp = Point({ p[b[uk].first].x, p[b[uk].first].y });
				Point sp = Point({ p[b[uk].second].x, p[b[uk].second].y });
				if (fp == c[i].first && sp == c[i].second) {
					ok1 = false;
					--uk;
					break;
				}
				if (fp == c[i].first) {
					continue;
				}
				if (sp == c[i].second) {
					continue;
				}
				if (has_inter(c[i].first, c[i].second, fp, sp)) {
					ok1 = false;
					--uk;
					break;
				}
			}
			if (ok1) {
				used[b[uk].first][b[uk].second] = true;
				int f = b[uk].first, s = b[uk].second;
				c.push_back(make_pair(Point{ p[f].x, p[f].y }, Point{ p[s].x, p[s].y }));
				cout << b[uk].first + 1 << ' ' << b[uk].second + 1 << endl;
				break;
			}
		}
	}

}