#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

void combine(int& x, int& cnt, int x2, int cnt2) {
    if (x2 > x) {
        x = x2;
        cnt = cnt2;
    } else if (x2 == x) {
        cnt += cnt2;
    }
}

int solve(string s) {
    reverse(s.begin(), s.end());
    while (s.size() > 1 && s.back() == '0') {
        s.pop_back();
    }
    int ans = 0, now = 0, last = -1;
    for (char c : s) {
        if (last == c - '0') {
            ++now;
        } else {
            if (now > ans) {
                ans = now;
            }
            now = 1;
            last = c -'0';
        }
    }
    if (now > ans) {
        ans = now;
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    set <string> st;
    int done = 0;
    string res(1 << n, '#');
    for (int l = 1; done < (1 << n); l *= 2) {
        string has;
        set<string> hs;
        for (int i = 0; i < done; i++) {
            has += res[i];
            if (has.length() == l) {
                hs.insert(has);
                has.clear();
            }
        }

        string current(l, '0');
        bool is_zero = false;
        while (!is_zero) {
            if (hs.find(current) == hs.end()) {
                for (int i = 0; i < l; i++) {
                    res[done + i] = current[i];
                }
                done += l;
                if (done == (1 << n)) {
                    break;
                }
            }

            for (int ci = l - 1; ci >= 0; ci--) {
                if (current[ci] == '1') {
                    current[ci] = '0';
                } else {
                    current[ci] = '1';
                    break;
                }
            }
            is_zero = true;
            for (char ch : current) {
                if (ch != '0') {
                    is_zero = false;
                    break;
                }
            }
        }
    }
    cout << res << endl;
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
