#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

int res = 0;

vector<vector<int>> clc(int n, int k) {
    vector<vector<int>> res;
    if (n == 0) {
        res.emplace_back();
        return res;
    }
    if (k == 1) {
        res.push_back(vector<int>(n, 1));
        return res;
    }
    for (int i = 0; i * k <= n; i++) {
        auto rs = clc(n - i * k, k - 1);
        for (auto &v : rs) {
            res.push_back(v);
            for (int j = 0; j < i; j++) {
                res.back().push_back(k);
            }
        }
    }
    return res;
}

const int MAXN = 20;
int fact[20];

int C(int n, int k) {
    return fact[n] / fact[k] / fact[n - k];
}

int cntpaint(int n, int k) {
    if (n == 0) {
        return 1;
    }
    if (k == 0) {
        return 0;
    }
    int ans = 0;
    for (int paint = 0; paint <= n; ++paint) {
        ans += cntpaint(n - paint, k - 1);
    }
    return ans;
}

void solve() {
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    int n, k;
    cin >> n >> k;
    auto pr = clc(n, 15);
    for (auto v : pr) {
        int cnt[16];
        memset(cnt, 0, sizeof(cnt));
        for (int i : v) {
            cnt[i]++;
        }
        int rs = 1;
        for (int e = 1; e <= 15; e++) {
            rs *= cntpaint(cnt[e], k);
        }
        res += rs;
    }
    cout << res << endl;
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
//     cin >> t;
    while (t--) solve();
}
