#ifndef ONPC
  #define _FORTIFY_SOURCE 0
  #pragma GCC optimize("Ofast")
  #pragma GCC optimize("no-stack-protector")
  #pragma GCC optimize("unroll-loops")
  #pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
  #pragma GCC optimize("fast-math")
#endif

#include <bits/stdc++.h>

#define mp make_pair
#define eb emplace_back
#define x first
#define y second

template <typename T>
bool chmax(T &a, const T &b) {
    if (a < b) {
      a = b;
        return true;
    }
    return false;
}

template <typename T>
bool chmin(T &a, const T &b) {
    if (a > b) {
      a = b;
      return true;
    }
    return false;
}

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pt;

#ifdef ONPC
mt19937 rnd(228);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 998244353LL;
const ld PI = acos(-1);

const int MAXN = 100;
//#define int long long
const int INF = 1e9;

ll kill(ll a, ll b){
  return min(a, b);
}

void solve(){
  int n;
  cin >> n;
  vector<ll> a(n), b(n);
  for (int i = 0; i < n; i++){
    cin >> a[i];
  }
  for (int i = 0; i < n; i++){
    cin >> b[i];
  }
  vector<pt> p(n + 1), s(n + 1);
  p[0] = {0LL, 0LL};
  s[n] = {0LL, 0LL};
  for (int i = 0; i < n; i++){
    ll a1 = p[i].x;
    ll b1 = p[i].y;
    ll a2 = a[i];
    ll b2 = b[i];
    ll k1 = kill(a2, b1);
    ll k2 = kill(a1, b2);
    p[i+1].x = a1 + a2 - k1 - k2;
    p[i+1].y = b1 + b2 - k1 - k2;
  }

  for (int i = n; i > 0; i--){
    ll a1 = s[i].x;
    ll b1 = s[i].y;
    ll a2 = a[i-1];
    ll b2 = b[i-1];
    ll k1 = kill(a2, b1);
    ll k2 = kill(a1, b2);
    s[i-1].x = a1 + a2 - k1 - k2;
    s[i-1].y = b1 + b2 - k1 - k2;
  }

  for (int i = 0; i < n; i++){
    ll a1 = p[i].x;
    ll b1 = p[i].y;
    ll a2 = s[i+1].x;
    ll b2 = s[i+1].y;
    ll k1 = kill(a1, b2);
    ll k2 = kill(a2, b1);

    if (b1 + b2 - k1 - k2 <= a[i]){
      cout << "YES\n";
      return;
    }
  }

  cout << "NO\n";
}

/*
#ifndef ONPC
#define FILEIO
#endif
*/
signed main()
{
    #ifdef FILEIO
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
    #endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int Q;
    cin >> Q;
    while (Q--)
      solve();

    return 0;
}
