import java.util.*;
import java.io.*;

public class Main {
    static Scanner sc = new Scanner(System.in);
    static PrintWriter pw = new PrintWriter(System.out);

    static String[] bin = new String[65536];
    static String[] zeros = {"", "0", "00", "000", "0000", "00000", "000000", "0000000", "00000000", "000000000", "0000000000", "00000000000", "000000000000", "0000000000000", "00000000000000", "000000000000000", "0000000000000000"};

    public static void main(String[] args) throws IOException {
        boolean[] used = new boolean[10000000];
        int n = sc.nextInt();
        int lenght = 1;
        for (int i = 0; i < n; i++)
            lenght *= 2;
        ArrayList<Integer> bacteries = new ArrayList<>();
        setBins();
        String ans = "";
        int pow2 = 1;
        int[] pows2 = new int[65537];
        pows2[0] = 1;
        for (int i = 1; i < pows2.length; i++)
            pows2[i] = pows2[i - 1] * 2;
        for (int size = 0; size < 5; size++) {
            int cnt = pows2[pow2];
            for (int i = 0; i < cnt; i++) {
                if (used[i])
                    continue;
                used[i] = true;
                bacteries.add(i);
            }
            ArrayList<Integer> newBact = new ArrayList<>();
            for (int i = 0; i < bacteries.size(); i += 2) {
                used[bacteries.get(i)] = false;
                used[bacteries.get(i + 1)] = false;
                newBact.add(bacteries.get(i) * cnt + bacteries.get(i + 1));
            }
            if (size != 4) {
                bacteries.clear();
                for (int bacteria : newBact) {
                    used[bacteria] = true;
                    bacteries.add(bacteria);
                }
                pow2 *= 2;
            }
        }
        if (lenght < 16)
            pw.print(bin[bacteries.get(0)].substring(0, lenght));
        else {
            for (int bacteria : bacteries) {
                lenght -= 16;
                pw.print(bin[bacteria]);
                if (lenght == 0)
                    break;
            }
        }
        pw.close();
    }

    static void setBins() {
        for (int i = 0; i < bin.length; i++)
            bin[i] = toBin(i, 16);
    }

    static String toBin(int a, int size) {
        String res = "";
        while (a > 0) {
            res = a % 2 + res;
            a /= 2;
        }
        return zeros[size - res.length()] + res;
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public Scanner(String file) throws FileNotFoundException {
        br = new BufferedReader(new FileReader(file));
    }

    public boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public String next() throws IOException {
        hasNext();
        return st.nextToken();
    }
}
