#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <climits>
#include <random>
#include <unordered_set>
#include <queue>
#include <bitset>

using namespace std;

#pragma warning (disable : 4996)

struct Marker
{
    int g;
    int b;
    Marker(int g, int b) : g(g), b(b) {}
    Marker() {};
    const bool operator< (const Marker& m) const
    {
        if (b != m.b)
            return b < m.b;
        return g < m.g;
    }
};

bool comp(Marker m1, Marker m2)
{
    if (m1.g != m2.g)
        return m1.g < m2.g;
    return m1.b < m2.b;
}

void resolve()
{
    long long n;
    cin >> n;
    vector<Marker> v(n);
    for (long long i = 0; i < n; i++)
        cin >> v[i].b;
    for (long long i = 0; i < n; i++)
        cin >> v[i].g;
    sort(v.rbegin(), v.rend(), comp);
    long long sum1 = 0, sum2 = 0;
    for (long long i = 0; i < n; i++)
        sum1 += v[i].b;
    for (long long i = 1; i < n; i++)
        sum2 += v[i].g;
    if (sum1 < sum2) {
        cout << "NO";
        return;
    }
    for (long long i = 1; i < n; i++) {
        if (sum1 - v[i].b < v[i].g) {
            cout << "NO";
            return;
        }
    }
    //v[0].g = 0;
    set<pair<Marker, int>> s1;
    set<pair<int, int>> s2;
    for (int i = 0; i < n; i++)
    {
        s1.insert({ v[i], i });
        s2.insert({ v[i].g, i });
    }
    while (s1.size() > 0 && s2.size() > 0)
    {
        auto mx = *s1.rbegin();
        auto mn = *s2.begin();
        if (mx.second == mn.second)
        {
            if (s2.size() == 1)
            {
                if (s1.size() == 1)
                {
                    cout << "YES";
                    return;
                }
                else
                    mx = *(----s1.end());
            }
            else
            {
                mn = *(++s2.begin());
            }
        }
        s2.erase(mn);
        s1.erase(mx);
        if (mx.first.b > mn.first)
        {
            mx.first.b -= mn.first;
            s1.insert(mx);
        }
        else if (mx.first.b < mn.first)
        {
            mn.first -= mx.first.b;
            s2.insert(mn);
        }
    }
    if (s2.size() > 1)
        cout << "NO";
    else
        cout << "YES";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef  _DEBUG
    freopen("input.txt", "r", stdin);
#endif 
    long long t;
    cin >> t;
    for (long long i = 0; i < t; i++)
    {
        resolve();
        cout << '\n';
    }
    return 0;
}