#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <climits>
#include <iomanip>
#include <iterator>
#include <cassert>

#ifndef LOCAL_BUILD
#pragma GCC optimize("-fcaller-saves,-fcrossjumping,-fthread-jumps,-funroll-loops,-fwhole-program,-freorder-blocks")
#pragma GCC optimize("-fpartial-inlining,-freorder-functions,-findirect-inlining,-fhoist-adjacent-loads,-ftree-vrp")
#pragma GCC optimize("-fsched-spec,-falign-jumps,-falign-loops,-falign-labels,-fdevirtualize,move-loop-invariants")
#pragma GCC optimize("-fschedule-insns,-fschedule-insns2,-fstrict-aliasing,-fdelete-null-pointer-checks,-fipa-sra")
#pragma GCC optimize("-fstrict-overflow,-falign-functions,-fcse-skip-blocks,-fcse-follow-jumps,-fsched-interblock")
#pragma GCC optimize("rename-registers,unr1oll-loops,inline-functions,inline-small-functions,vpt,function-sections")
#pragma GCC optimize("-frerun-cse-after-loop,-finline-small-functions,-ftree-switch-conversion,-ftree-tail-merge")
#pragma GCC optimize("-foptimize-sibling-calls,-fexpensive-optimizations,-funsafe-loop-optimizations,-ftree-pre")
#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
#pragma GCC optimize("inline-functions-called-once,tracer,profile-reorder-functions,unswitch-loops,-fgcse-lm")
#pragma GCC optimize("branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,-fpeephole2")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx2")
#pragma warning(disable : 4996)
#define _CRT_SECURE_NO_WARNINGS
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = 1e9 + 33;
ll GG = 1e15;
const ld PI = acosl(-1);

#define speed                         \
    ios_base::sync_with_stdio(false); \
    cin.tie(0);                       \
    cout.tie(0)

void solve();
signed main() {
    speed;
    solve();
}

int ctz(int v) {
    int cnt = 0;
    while (v) {
        v >>= 1;
        cnt++;
    }
    return cnt;
}

void add(string& s, int v, int len) {
    string a;
    while (len--) {
        a.push_back('0' + v % 2);
        v >>= 1;
    }
    reverse(a.begin(), a.end());
    s += a;
}

bool isDv(int a) {
    return a == 1 << (ctz(a) - 1);
}

int from_string(string s) {
    int ans = 0;
    for (int i = 0; i < s.size(); i++) {
        ans += (s[s.size() - i - 1] - '0') * (1 << i);
    }
    return ans;
}

//int build(string& s, int len, vector<set<int>>& used, vector<int>& current) {
//    if (used[len].size() == pow(2, len)) {
//        return -1;
//    }
//    if (len == 1) {
//        if (used[1].size() == 0) {
//            add(s, 0, len);
//            used[1].insert(0);
//            return 0;
//        }
//        else {
//            add(s, 1, len);
//            used[1].insert(1);
//            return 1;
//        }
//    }
//    int a = build(s, len - 1, used, current);
//    int b = build(s, len - 1, used, current);
//    if (b == -1 && a == -1) {
//    }
//    int r = a * (1 << len) + b;
//    used[len].insert(r);
//}

void solve() {
    int n;
    cin >> n;
    int des_l = 1 << n;
    
    int cur = 0;
    int len = 1;
    string s = "";
    vector<set<int>> used(20);
    vector<int> current(20, 0);
    while (s.size() + len <= des_l) {
        add(s, cur, len);
        if (isDv(s.size())) {
            used[ctz(s.size())].insert(from_string(s));
        }
        cur++;
        if (cur == 1 << len) {
            len++;
            cur = 0;
        }
        while (used[len].count(cur)){
            cur++;
            if (cur == 1 << len) {
                len++;
                cur = 0;
            }
        }
    }
    while (s.size() != des_l)
        s += '0';
    cout << s << "\n";
}