#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string.h>
#include <sstream>
#include <stack>
#include <stdio.h>
#include <vector>
#include <bitset>
#include <queue>
 
using namespace std;
 
typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef set<ll> sll;
 
 
void acceleration () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
 
void formatting () {
    cout << fixed;
    cout.precision(3);
    cout << setprecision(2);
}

void solve();
 
int main () {
    acceleration();
    solve();
}
ll const N = 1e6 + 10, mod = 1e9 + 7;
ll a[3*N];

ll GCD (ll a, ll b){
    if(!b) return a;
    return GCD(b, a % b);
}

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    if (k % 2 == 0) return (binpow(n, k / 2) * binpow(n, k / 2)) % mod;
    else return (n * binpow(n, k - 1)) % mod;
}

void solve () {
    int t1, v1, t2, v2;
    cin >> t1 >> v1 >> t2 >> v2;
    if(t2 < 0 && v1 >= 10) {
        cout << "A storm warning for tomorrow! Be careful and stay home if possible!";
        return;
    }
    if(t2 < t1) {
        cout << "MCHS warns! Low temperature is expected tomorrow.";
        return;
    }
    if(v2 > v1) {
        cout << "MCHS warns! Strong wind is expected tomorrow.";
        return;
    }
    cout << "No message";
    return;
}
