#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <string>
#include <set>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

int n, k;

vector<vector<ll>> qwer(0);
vector<vector<ll>> ffir(17, vector<ll>(17, -1)), psec(17, vector<ll>(17, -1));

ll f(int q, int w) {
    if (ffir[q][w] >= 0) return ffir[q][w];
    if (q == 0) return 1;
    if (w == 0) return 0;
    ll sum = 0;
    for (int i = 0; i <= w; ++i) {
        if (q - i >= 0) {
            sum += f(q - i, i);
        }
    }
    ffir[q][w] = sum;
    return sum;
}

ll p(int q, int w) {
    if (psec[q][w] >= 0) return psec[q][w];
    if (q == 0) return 1;
    if (w == 0) return 0;
    ll sum = 0;
    for (int i = 0; i <= q; ++i) {
        sum += f(i, i) * p(q - i, w - 1);
    }
    psec[q][w] = sum;
    return sum;
}

int main() {
    cin >> n >> k;
    cout << p(n, k);
}