#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define int long long
#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())


typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = 3.1415926535897932384626433832795;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;
ld START_TIME, TIME;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<map<int, int>> mp;

void f(int left, int cur, vector<int> ans) {
    if (left == 0) {
        map<int, int> m;
        for (auto i : ans) {
            m[i] += 1;
        }
        mp.push_back(m);
        return;
    }
    for (int i = min(left, cur); i > 0; --i ) {
        ans.push_back(i);
        f(left - i, i, ans);
        ans.pop_back();
    }
}

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> v;

    vector<int> kk(n + 1);

    kk[0] = 1;
    for (int i = 1; i < n + 1; ++i) {
        kk[i] = kk[i - 1] * k;
    }

    f(n, n, v);

    int ans = 0;

    for (auto& m : mp) {
        int cur = 1;
        for (auto [first, second] : m) {
            cur *= (kk[second] - k) / second + k;
//            cout << second << ' ' << cur << '\n';
        }
//        cout << '\n';
        ans += cur;
    }

    cout << ans;
}

int32_t main() {
    START_TIME = clock();
    fast_in_out();
#ifdef __APPLE__
    freopen("a.in", "r", stdin);
//    freopen("a.out", "w", stdout);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
#ifdef __APPLE__
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << en << TIME * 1000 << " ms." << en;
#endif
    return 0;
}
