﻿#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>

#define rep(i, n) for(ll i = 0; i < n; ++i)
#define in(x, a) for(auto x : a)
#define inl(x, a) for(auto& x : a)

using namespace std;

using ll = long long;
ll const INF = 1e9;
ll const MOD = 1e9 + 7;

ll ans;
vector<vector<ll>> dp;

void builddp(int n, int k) {
    dp.resize(n + 1, vector<ll>(k, 1));
    for (int i = 1; i <= n; ++i) {
        ll t = 0;
        for (int j = k - 1; j >= 0; --j) {
            t += dp[i - 1][j];
            dp[i][j] = t;
        }
    }
}

void gen(int n, int sum, vector<int>& cur, vector<int>& cnt) {
    if (sum == n) {
        ll t = 1;
        rep(i, n + 1) {
            t *= dp[cnt[i]][0];
        }
        ans += t;
        return;
    }
    if (sum > n) {
        return;
    }
    for (int i = n; i >= max(1, cur.back()); --i) {
        cur.push_back(i);
        cnt[i]++;
        gen(n, sum + i, cur, cnt);
        cur.pop_back();
        cnt[i]--;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    int n, k;
    cin >> n >> k;
    builddp(n, k);

    rep(i, n) {
        vector<int> cur = { (int)i + 1 }, cnt(n + 1);
        cnt[i + 1] = 1;
        gen(n, i + 1, cur, cnt);
    }
    cout << ans;
}