#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

template <class T = int>
T next() { T x; cin >> x; return x; }

int _size = 1;
vector<int> tree;
#define ls(v) (v << 1)
#define rs(v) ((v << 1) + 1)

void update(int v)
{
    if (v == 0) return;
    tree[v] = tree[ls(v)] + tree[rs(v)];
    update(v >> 1);
}

int get_ans(int l, int r)
{
    int ans = 0;
    l += _size, r += _size;

    while (l <= r)
    {
        if (l & 1) ans += tree[l++];
        if (~r & 1) ans += tree[r--];
        l >>= 1, r >>= 1;
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0); cin.tie(0);

    int n, m, s;
    cin >> n >> m >> s;
    int realm = min(2 * m, n);
    
    while (_size <= realm)
        _size <<= 1;

    tree.resize(_size << 1);
    
    for (int i = 0; i < m; i++)
    {
        int x = next() - 1;
        tree[x + _size] = 1;
        update(x + _size >> 1);
    }

    int count = 0;
    for (int i = 0; i + m - 1 < realm; i++)
    {
        int ans = get_ans(i, i + m - 1);

        if (ans + s >= m)
            count++;
    }
    
    cout << count << '\n';

    return 0;
}