#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cmath>
#include <random>
#include <unordered_map>
#define int long long
using namespace std;

struct point {
	int x, y;
};

struct vec {
	int x, y;
	int operator*(const vec &b) {
		return x * b.x + y * b.y;
	}
	int operator^(const vec& b) {
		return x * b.y - y * b.x;
	}
	vec(point a, point b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

bool check(point a, point b, point c) {
	return (c.x - a.x) * (b.y - a.y) - (c.y - a.y) * (b.x - a.x) <= 0;
}

bool inters(point a, point b, point c, point d) {
	vec v1(a, b);
	vec v2(a, c);
	vec v3(a, d);
	vec v4(c, d);
	vec v5(c, b);
	vec v6(c, a);
	return (v1 ^ v2) * (v1 ^ v3) < 0 && (v4 ^ v5) * (v4 ^ v6) < 0;
}

bool cmp(point a, point b) {
	return (a.x < b.x) || (a.x == b.x && a.y < b.y);
}

signed main() {
	int n;
	cin >> n;
	vector <point> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
	}
	sort(p.begin(), p.end(), cmp);
	int counter = 0, l = 0, tre = 0;
	int used[300];
	memset(used, 0, 300);
	vector <int> verx;
	vector <int> niz;
	while (n - counter > 2) {
		verx.clear();
		niz.clear();
		l = 0;
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;
			while (l > 1 && check(p[verx[l - 2]], p[verx[l - 1]], p[i])) {
				used[verx[l - 1]] = 0;
				verx.pop_back();
				l--;
			}
			used[i] = 1;
			verx.push_back(i);
			l++;
		}
		used[verx[0]] = 0;
		used[verx[l - 1]] = 0;
		l = 0;
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;
			while (l > 1 && check(p[niz[l - 2]], p[i], p[niz[l - 1]])) {
				used[niz[l - 1]] = 0;
				niz.pop_back();
				l--;
			}
			used[i] = 1;
			niz.push_back(i);
			l++;
		}
		counter += (int) verx.size();
		counter += (int)niz.size();
		counter -= 2;
		if (tre == 0) {
			tre += (int)verx.size();
			tre += (int)niz.size();
			tre -= 2;
		}
		else {
			tre += ((int)verx.size() + (int)niz.size() - 2) * 2;
		}
	}
	tre += counter;
	if (n == counter) {
		tre -= 3;
	}
	else if (n == counter + 1) {
	}
	else if (n == counter + 2) {
		tre += 3;
	}
	if (tre % 2 == 0) {
		cout << 2 << endl;
	}
	else {
		cout << 1 << endl;
	}
	vector <vector <int>> pare(n, vector <int>(n, 1));
	if (tre % 2 == 0) {
		while (true) {
			int a, b;
			cin >> a >> b;
			if (a == 0) return 0;
			a--;
			b--;
			pare[a][b] = 0;
			pare[b][a] = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (i == j || i == a || i == b || j == a || j == b) continue;
					if (inters(p[a], p[b], p[i], p[j])) {
						pare[i][j] = 0;
						pare[j][i] = 0;
					}
				}
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (i == j) continue;
					if (pare[i][j] == 1) {
						a = i; b = j;
					}
				}
			}
			pare[a][b] = 0;
			pare[b][a] = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (i == j || i == a || i == b || j == a || j == b) continue;
					if (inters(p[a], p[b], p[i], p[j])) {
						pare[i][j] = 0;
						pare[j][i] = 0;
					}
				}
			}

			cout << a + 1 << " " << b + 1 << endl;
		}
	}
	int a, b;
	cout << 1 << " " << 2 << endl;
	a = 1;
	b = 2;
	pare[1][2] = 0;
	pare[2][1] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j || i == a || i == b || j == a || j == b) continue;
			if (inters(p[a], p[b], p[i], p[j])) {
				pare[i][j] = 0;
				pare[j][i] = 0;
			}
		}
	}
	while (true) {

		cin >> a >> b;
		if (a == 0) return 0;
		a--;
		b--;
		pare[a][b] = 0;
		pare[b][a] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j || i == a || i == b || j == a || j == b) continue;
				if (inters(p[a], p[b], p[i], p[j])) {
					pare[i][j] = 0;
					pare[j][i] = 0;
				}
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j) continue;
				if (pare[i][j] == 1) {
					a = i; b = j;
				}
			}
		}
		pare[a][b] = 0;
		pare[b][a] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j || i == a || i == b || j == a || j == b) continue;
				if (inters(p[a], p[b], p[i], p[j])) {
					pare[i][j] = 0;
					pare[j][i] = 0;
				}
			}
		}

		cout << a + 1 << " " << b + 1 << endl;
	}
}