#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) (a).begin(), (a).end()
#define pb push_back

int sign(ll a) {
    if (a < 0) return -1;
    return a > 0;
}

struct point {
    int x, y;
    point() {}
    point(int x_, int y_) {
        x = x_;
        y = y_;
    }
    void input() {
        cin >> x >> y;
    }

    void show() {
        cout << "(" << x << ", " << y << ") ";
    }

    ll len() {
        return (ll)x * x + (ll)y * y;
    }
    ld rlen() {
        return sqrt(len());
    }

    void operator+=(point b) {
        x += b.x;
        y += b.y;
    }
    point operator+(point b) {
        return point(x + b.x, y + b.y);
    }

    void operator-=(point b) {
        x -= b.x;
        y -= b.y;
    }
    point operator-(point b) {
        return point(x - b.x, y - b.y);
    }

    ll operator%(point b) {
        return (ll)x * b.y - (ll)y * b.x;
    }
    ll operator*(point b) {
        return (ll)x * b.x + (ll)y * b.y;
    }
};

ld dist(point a, point b) {
    return (a - b).rlen();
}

struct segment {
    point a, b;
    segment() {}
    segment(point a_, point b_) {
        a = a_;
        b = b_;
    }
    ld rlen() {
        return (a - b).rlen();
    }
    void show() {
        cout << "{ ";
        a.show(), b.show();
        cout << "} ";
    }

    // вектор нормали // правый?
    point n() {
        point p = a - b;
        return point(-p.y, p.x);
    }
};

ld line_dist(point a, segment b) {
    point v1 = a - b.a, v2 = b.b - b.a;
    return abs(v1 % v2) / b.rlen();
}

ld dist(point a, segment b) {
    point n = b.n();
    if (sign(n % (b.a - a)) * sign(n % (b.b - a)) < 0) {
        return line_dist(a, b);
    }
    return min((b.a - a).rlen(), (b.b - a).rlen());
}

bool intersect(segment a, segment b) {
    // intersect
    if (sign((a.b - a.a) % (b.a - a.a)) * sign((a.b - a.a) % (b.b - a.a)) < 0 &&
        sign((b.b - b.a) % (a.b - b.a)) * sign((b.b - b.a) % (a.a - b.a)) < 0) {
        return 1;
    }
    return 0;
}


int n;
vector<point> v;

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	v.resize(n);
	vector<vector<int>> g;
	g.assign(n, vector<int>(n, 0));
	for (int i = 0; i < n; i++) {
		v[i].input();
	}
	vector<segment> otr;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			segment s = segment(v[i], v[j]);
			int f = 1;
			for (auto e : otr) {
				if (intersect(e, s)) {
					f = 0;
					break;
				}
			}
			if (f) {
				otr.pb(s);
			}
		}
	}
	int x = 0;


	if (otr.size() % 2 == 0) {
		cout << "2" << endl;
		x = 1;
	} else {
		cout << "1" << endl;
	}

	otr.resize(0);

	int tx = 0, ty = 1;

	while (1) {
		pii t;
		if (x == 1) {
			cin >> t.first >> t.second;
			if (t.first == 0 && t.second == 0) {
				break;
			}
			otr.pb(segment(v[t.first - 1], v[t.second - 1]));
			g[t.first - 1][t.second - 1] = 1;
			g[t.second - 1][t.first - 1] = 1;
		} else {
			int ff = 0;
			for (; tx < n; tx++) {
				for (; ty < n; ty++) {

					if (g[tx][ty]) continue;
					segment s = segment(v[tx], v[ty]);
					int f = 1;
					for (auto e : otr) {
						if (intersect(e, s)) {
							f = 0;
							break;
						}
					}
					if (f) {
						cout << tx + 1 << " " << ty + 1 << endl;
						otr.pb(s);
						g[tx][ty] = 1;
						g[tx][ty] = 1;
						ff = 1;
						break;
					}
				}
				if (ff) break;
				ty = tx + 2;
			}
		}
		x = x ^ 1;
	}



	return 0;
}