﻿#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>


struct Vector {
	int64_t x, y;

	Vector(int64_t x = 0, int64_t y = 0) : x(x), y(y) {
		;
	}

	int64_t operator%(const Vector &other)const {
		return x * other.y - y * other.x;
	}

	int64_t operator*(const Vector &other)const {
		return x * other.y - y * other.x;
	}

	Vector operator-(const Vector &other)const {
		return Vector(x - other.x, y - other.y);
	}

	bool operator==(const Vector &other)const {
		return (x == other.x) && (y == other.y);
	}
};


struct Seg {
	Vector a, b;
};


bool inter(const Seg &l, const Seg &r) {
	int64_t a1 = ((l.b - l.a) % (r.a - l.a));
	int64_t a2 = ((l.b - l.a) % (r.b - l.a));

	int64_t b1 = ((r.b - r.a) % (l.a - r.a));
	int64_t b2 = ((r.b - r.a) % (l.b - r.a));

	if (((a1 == 0) || (a2 == 0) || ((a1 > 0) xor (a2 > 0))) && ((b1 == 0) || (b2 == 0) || ((b1 > 0) xor (b2 > 0)))) {
		return true;
	}
	return false;
}


Vector input[305];
int n;
std::vector<std::pair<int, int>> vec;


std::pair<int, int> fn(std::pair<int, int> p, bool ff) {
	if (ff) {
		std::cout << p.first + 1 << ' ' << 1 + p.second << '\n';
		std::cout.flush();
	}
	int a, b;
	std::cin >> a >> b;
	if ((a == 0) && (b == 0)) {
		exit(0);
	}
	return { a - 1, b - 1 };
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	for (int i = 0; i < n; i++) {
		std::cin >> input[i].x >> input[i].y;
	}

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			vec.push_back({ i, j });
		}
	}

	int cnt = 0;
	while (!vec.empty()) {
		Seg s = { input[vec.back().first], input[vec.back().second] };
		vec.pop_back();

		vec.resize(std::remove_if(vec.begin(), vec.end(), [&](const std::pair<int, int> &tt) {
			Seg t = { input[tt.first], input[tt.second] };
			return inter(s, t) && !((t.a == s.a) || (t.a == s.b) || (t.b == s.a) || (t.b == s.b));
		}) - vec.begin());

		cnt++;
	}

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			vec.push_back({ i, j });
		}
	}
	std::cerr << cnt << '\n';

	if (cnt % 2) {
		std::cout << "1" << std::endl;

	} else {
		std::cout << "2" << std::endl;
		auto p = fn({ 0, 0 }, false);

		Seg s = { input[p.first], input[p.second] };
		vec.resize(std::remove_if(vec.begin(), vec.end(), [&](const std::pair<int, int> &tt) {
			Seg t = { input[tt.first], input[tt.second] };
			return inter(s, t) && !((t.a == s.a) || (t.a == s.b) || (t.b == s.a) || (t.b == s.b));
		}) - vec.begin());
	}

	while (!vec.empty()) {
		Seg s = { input[vec.back().first], input[vec.back().second] };
		auto p = fn(vec.back(), true);
		vec.pop_back();
		vec.resize(std::remove_if(vec.begin(), vec.end(), [&](const std::pair<int, int> &tt) {
			Seg t = { input[tt.first], input[tt.second] };
			return inter(s, t) && !((t.a == s.a) || (t.a == s.b) || (t.b == s.a) || (t.b == s.b));
		}) - vec.begin());

		s = { input[p.first], input[p.second] };
		vec.resize(std::remove_if(vec.begin(), vec.end(), [&](const std::pair<int, int> &tt) {
			Seg t = { input[tt.first], input[tt.second] };
			return inter(s, t) && !((t.a == s.a) || (t.a == s.b) || (t.b == s.a) || (t.b == s.b));
		}) - vec.begin());

		cnt++;
	}



}