﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>


using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second

struct Event {
	int x;
	bool type;
	Event() {};
	Event(int x_, bool type_) {
		x = x_;
		type = type_;
	}
	const bool operator<(const Event& other) {
		if (x < other.x)
			return true;
		if (x > other.x)
			return false;
		return type > other.type;
	}
};

void solve() {
	int n, m, s;
	cin >> n >> m >> s;
	vector<int> table(m);
	for (int i = 0; i < m; i++)
		cin >> table[i];
	sort(table.begin(), table.end());
	table.resize(unique(table.begin(), table.end()) - table.begin());
	vector<Event> events;
	events.reserve(table.size() * 2 + m - 1);
	for (int card : table) {
		events.push_back(Event(max(1, card - m + 1), 0));
		events.push_back(Event(min(n - m + 2, card + 1), 1));
	}
	sort(events.begin(), events.end());
	int cur_sum = s;
	int last = 0;
	int ans = 0;
	for (Event e : events) {
		if (cur_sum >= m)
			ans += e.x - last;
		last = e.x;
		if (e.type)
			cur_sum--;
		else
			cur_sum++;
	}
	if (cur_sum >= m)
		ans += (n - m + 1) - last;
	cout << ans;
}

const int maxN = 20;
long long int dp[maxN][maxN][maxN];

int32_t main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	solve();
}