#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <iomanip>
#include <map>
#include <cmath>
#include <bitset>
#include <utility>
#include <queue>
#include <iterator>
#include <climits>
#include <random>
#include <sstream>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cassert>
using namespace std;
typedef long long int ll;
#define int long long

vector<int> hist, boost;

void presolve(int n, int k) {
    boost.resize(n + 1, 1);
    vector<vector<int>> dp(n + 1, vector<int> (k));
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            for (int x = j; x < k; ++x) {
                dp[i + 1][x] += dp[i][j];
            }
        }
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 1; j < k; ++j) {
            boost[i] += dp[i][j];
        }
    }
}

ll solve(int n, int k, int max) {
    if (n < 0)
        return 0;
    if (n == 0) {
        ll ans = 1;
        for (int i = 0; i < hist.size(); ++i) {
            ans *= boost[hist[i]];
        }
        return ans;
    }
    ll res = 0;
    for (int i = 1; i <= max; ++i) {
        hist[i]++;
        res += solve(n - i, k, i);
        hist[i]--;
    }
    return res;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, k;
    cin >> n >> k;
    presolve(n, k);
    hist.resize(n + 1);
    cout << solve(n, k, n);
    return 0;
}
