#include <bits/stdc++.h>

using namespace std;

//#pragma target("sse,sse2,sse3,ssse3,sse,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i : a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DOUT
        cout << x;
#endif
        return *this;
    }
} dout;

LogOutput fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

#define nl '\n'
#define elif else if
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v.size())
#define sqr(v) ((v) * (v))
#define vpi vector<pair<int, int>>
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % (m)) + (m))) % m)
#define vi vector<int>
#define pi pair<int, int>
#define ti tuple<int, int, int>
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max((x), (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double Pi = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    cout.setf(ios::fixed);
    cout.precision(10);
}

typedef int T;

const double EPS = 1e-8;

bool IsEqual(T a, T b) {
    return abs(a - b) <= EPS;
}

struct Vector {
    T x, y;

    Vector() : x((T) 0), y((T) 0) {};

    Vector(T x, T y) : x(x), y(y) {};

    Vector(Vector a, Vector b) : x(b.x - a.x), y(b.y - a.y) {};

    void operator+=(const Vector b) {
        x += b.x;
        y += b.y;
    }

    void operator-=(const Vector b) {
        x -= b.x;
        y -= b.y;
    }

    void operator*=(const T b) {
        x *= b;
        y *= b;
    }

    void operator/=(const T b) {
        x /= b;
        y /= b;
    }

    Vector operator+(const Vector a) const {
        Vector t = (*this);
        t += a;
        return t;
    }

    Vector operator-(const Vector a) const {
        Vector t = (*this);
        t -= a;
        return t;
    }

    Vector operator*(const T a) const {
        Vector t = (*this);
        t *= a;
        return t;
    }

    Vector operator/(const T a) const {
        Vector t = (*this);
        t /= a;
        return t;
    }

    T operator*(Vector b) const { // scalar
        return x * b.x + y * b.y;
    }

    T operator%(Vector b) const { // vector
        return x * b.y - y * b.x;
    }

    Vector Normal() const {
        return Vector(-y, x);
    }

    T Len2() const {
        return sqr(x) + sqr(y);
    }

    double Len() const {
        return sqrt(Len2());
    }

    bool operator==(Vector b) const {
        return abs(x - b.x) == 0 && abs(y - b.y) == 0;
    }

    Vector Rotate(double angle) const {
        return Vector(x * cos(angle) - y * sin(angle),
                      x * sin(angle) + y * cos(angle));
    }
};

typedef Vector Point;

istream &operator>>(istream &is, Point &p) {
    is >> p.x >> p.y;
    return is;
}

struct Line {
    T A, B, C;

    Line() : A(0), B(0), C(0) {};

    Line(const T A, const T B, const T C) : A(A), B(B), C(C) {};

    Line(const Point p1, const Point p2) {
        A = p2.y - p1.y;
        B = p1.x - p2.x;
        C = -(p1.y * B + p1.x * A);
    }

    double Dist(const Point &P) const {
        return abs(A * P.x + B * P.y + C) / (double) sqrt(A * A + B * B);
    }

    Point Cross(const Line &l) const { /////////////////////////// vizivat tolko esli ne parallelni, inache assert
        T A1 = A;
        T B1 = B;
        T C1 = C;
        T A2 = l.A;
        T B2 = l.B;
        T C2 = l.C;
        T znam = A1 * B2 - A2 * B1;
        assert(abs(znam) > EPS); //////////////////////////////////////////////////// assert
        T x = -(C1 * B2 - C2 * B1) / znam;
        T y = -(A1 * C2 - A2 * C1) / znam;
        return Point(x, y);
    }

    Vector Norm() const {
        return Vector(A, B);
    }

    Vector Napr() const {
        return Vector(-B, A);
    }
};

istream &operator>>(istream &is, Line &l) {
    is >> l.A >> l.B >> l.C;
    return is;
}

struct Circle {
    Point O;
    T r;

    Circle() : O(0, 0), r(0) {};

    Circle(const Point O, const T r) : O(O), r(r) {};

    vector<Point> Cross(const Line a) const {
        T d = a.Dist(O);
        if (d - r > EPS) {
            return {};
        }
        Vector OH = a.Norm();
        OH /= OH.Len();
        OH *= d;
        Point H = O + OH;
        if (!IsEqual(a.Dist(H), 0)) {
            H = O - OH;
        }
        if (abs(d - r) <= EPS) {
            return {H};
        }
        double a1 = sqrt(sqr(r) - sqr(d));
        Vector HA = a.Napr();
        HA /= HA.Len();
        HA *= a1;
        return {H + HA, H - HA};
    }

    bool operator==(const Circle w) const {
        return abs(r - w.r) <= EPS && w.O == O;
    }

    vector<Point> Cross(Circle w2) const {
        Circle w1(O, r);
        if (w1.r < w2.r) {
            swap(w1, w2);
        }
        Vector O1O2(w1.O, w2.O);
        if (O1O2.Len2() < sqr(w1.r - w2.r) || O1O2.Len2() > sqr(w1.r + w2.r)) {
            return {};
        }
        if (IsEqual(O1O2.Len2(), sqr(w1.r - w2.r)) || IsEqual(O1O2.Len2(), sqr(w1.r + w2.r))) {
            O1O2 /= O1O2.Len();
            O1O2 *= w1.r;
            return {w1.O + O1O2};
        }
        double angle = acos((sqr(w1.r) + O1O2.Len2() - sqr(w2.r)) / (2 * w1.r * O1O2.Len()));
        O1O2 /= O1O2.Len();
        O1O2 *= w1.r;
        auto a = O1O2.Rotate(angle);
        auto b = O1O2.Rotate(-angle);
        return {w1.O + a, w1.O + b};
    }

    vector<Point> TangencyPoints(const Point P) const {
        Vector PO(P, O);
        if (r - PO.Len() > EPS) {
            return {};
        }
        if (IsEqual(PO.Len(), r)) {
            return {P};
        }
        double len = sqrt(PO.Len2() - r * r);
        double angle = asin(r / PO.Len());
        PO /= PO.Len();
        Vector a = PO.Rotate(angle);
        Vector b = PO.Rotate(-angle);
        return {P + a * len, P + b * len};
    }

    Line CommonExternalTangent(const Circle w) const {
        Vector O1O2(O, w.O);
        double d = sqrt(O1O2.Len2() - sqr(r - w.r));
        double angle = 0;
        if (r > w.r) {
            angle = abs(acos((r - w.r) / O1O2.Len()));
            O1O2 = O1O2.Rotate(-angle);
        } else {
            angle = -(abs(acos(d / O1O2.Len())) + acos(-1) / 2);
            O1O2 = O1O2.Rotate(angle);
        }
        O1O2 /= O1O2.Len();
        auto P1(O + O1O2 * r);
        auto P2(w.O + O1O2 * w.r);
        return Line(P1, P2);
    }

    double LenOfArc(const Point A, const Point B) const {
        Vector OA(O, A), OB(O, B);
        double alpha = abs(acos(OA * OB / OA.Len() / OB.Len()));
        return 2 * r * alpha;
    }
};

istream &operator>>(istream &is, Circle &w) {
    is >> w.O >> w.r;
    return is;
}

int sign(int a) {
    if (a == 0) {
        return 0;
    }
    if (a > 0) {
        return 1;
    }
    return -1;
}

bool AreIntersect(Point A1, Point B1, Point A2, Point B2) {
    if (A1 == A2 || A1 == B2 || B1 == A2 || B1 == B2) {
        return 0;
    }
    Vector A1A2(A1, A2), A1B2(A1, B2), A1B1(A1, B1), B1A1(B1, A1), B1A2(B1, A2), B1B2(B1, B2), A2A1(A2, A1), A2B2(A2,
                                                                                                                  B2), A2B1(
            A2, B1), B2A1(B2, A1), B2A2(B2, A2), B2B1(B2, B1);
    return sign(A1A2 % A1B1) == sign(A1B1 % A1B2) && sign(B1B2 % B1A1) == sign(B1A1 % B1A2) &&
           sign(A2A1 % A2B2) == sign(A2B2 % A2B1) && sign(B2A1 % B2A2) == sign(B2A2 % B2B1);
}

void Solve() {
    int n;
    cin >> n;
    vector<Point> v(n);
    cin >> v;
    vector<pair<Point, Point>> segments;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            bool f = 1;
            for (auto[A2, B2] : segments) {
                if (v[i] == A2 && v[j] == B2) {
                    continue;
                }
                if (AreIntersect(v[i], v[j], A2, B2)) {
                    f = 0;
                    break;
                }
            }
            if (f) {
                segments.pb({v[i], v[j]});
            }
        }
    }
    int cnt = segments.size();
    vector<vector<int>> used(n, vector<int>(n, 0));
    segments.clear();
    if (cnt % 2) {
        cout << 1 << endl;
        cout << "1 2" << endl;
        used[0][1] = 1;
        used[1][0] = 1;
        segments.pb({v[0], v[1]});
        cnt--;
    } else {
        cout << 2 << endl;
    }
    while (cnt) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        used[a][b] = 1;
        used[b][a] = 1;
        segments.pb({v[a], v[b]});
        cnt--;
        if (cnt == 0) {
            break;
        }
        bool f = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (used[i][j]) {
                    continue;
                }
                used[i][j] = 1;
                used[j][i] = 1;
                bool f1 = 1;
                for (auto[A2, B2] : segments) {
                    if (AreIntersect(v[i], v[j], A2, B2)) {
                        f1 = 0;
                        break;
                    }
                }
                if (f1) {
                    f = 1;
                    cout << i + 1 << ' ' << j + 1 << endl;
                    cnt--;
                    segments.pb({v[i], v[j]});
                    break;
                }
            }
            if (f) {
                break;
            }
        }
    }
}

signed main() {
    // IO();
    int t = 1;
    // cin >> t;
    int startTime = clock();
    while (t--) {
        Solve();
    }
    int endTime = clock();
    dout << '\n' << "Time: " << (endTime - startTime + 999) / 1000;
    return 0;
}