#define _USE_MATH_DEFINES

#include <iostream>
#include <random>
#include <iomanip>
#include <functional>
#include <vector>
#include <set>
#include <map>
using namespace std;

#ifndef DEBUG
//#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")
#endif

std::random_device rn;
std::mt19937 rng(rn());

typedef long long ll;
typedef long double ld;

#ifdef DEBUG
int time_DEBUG;
#endif

void geom_out() {
    std::cout.setf(std::ios::fixed);
#ifdef DEBUG
    std::cout << std::setprecision(8);
#else
    std::cout << std::setprecision(35);
#endif
}

void fast_in_out() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void begin_ex() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    time_DEBUG = clock();
#endif
    fast_in_out();
    geom_out();
}

void end_ex() {
#ifdef DEBUG
    std::cerr << '\n' << static_cast<double>(clock() - time_DEBUG) / (CLOCKS_PER_SEC * 1.0) << " sec\n";
#endif
}

void solve() {
    int n, s, m;
    cin >> n >> m >> s;
    vector<int> a(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
    long long ans = 0;
    auto getCnt = [&](int l, int r) {
        return upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
    };
    for (int i = 0; i < (int)a.size(); i++) {
        int l = i ? a[i - 1] + 1 : 1;
        l--;
        int r = min(n - m + 1, a[i]);
        int L = l, R = r;
        if (l >= r) continue;
        auto f = [&](int x) {
            return m - getCnt(x, x + m - 1) <= s;
        };
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (f(mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (f(r)) ans += R - r + 1;
    }
    cout << ans << '\n';
}

signed main() {
    begin_ex();

    int t = 1;
//    cin >> t;
    while (t--)
        solve();

    end_ex();
    return 0;
}