import functools
import itertools
import math


@functools.lru_cache(maxsize=None)
def combos(m, c):
    if m < c:
        return []
    elif m == c:
        return [(1,) * c]
    elif c == 1:
        return [(m,)]
    result = []
    for i in range(1, m - c + 1):
        for b in combos(m - i, c - 1):
            result.append((i,) + b)
    return result


def cnk(n, k):
    return math.factorial(n) / (math.factorial(k) * math.factorial(n - k))


def allcombos(m):
    cs = itertools.chain(*[combos(m, c) for c in range(1, m + 1)])
    cs = set(tuple(sorted(c)) for c in cs)
    return cs


def counts(t):
    return {n: t.count(n) for n in t}


n, k = map(int, input().split())
total = 0
for combo in allcombos(n):
    cts = counts(combo)
    subtotals = []
    for ct in cts.values():
        subtotal = 0
        for cm in allcombos(ct):
            if len(cm) <= k:
                subtotal += cnk(k, len(cm)) * math.factorial(len(cm))
        subtotals.append(subtotal)
    if len(subtotals):
        total += functools.reduce((lambda a, b: a * b), subtotals)
print(int(total))
