#include<bits/stdc++.h>

using namespace std;

template <typename A, typename B>
string to_string(pair<A, B> p);

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p);

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p);

string to_string(const string& s) {
    return '"' + s + '"';
}

string to_string(const char& s) {
    string res = "'";
    res += s;
    res += "'";
    return res;
}

string to_string(bool b) {
    return (b ? "true" : "false");
}

string to_string(vector<bool> v) {
    string res = "{";
    for (int i = 0; i < static_cast<int>(v.size()); i++) {
        if (i) res += ", ";
        res += to_string(v[i]);
    }
    res += "}";
    return res;
}

template <size_t N>
string to_string(bitset<N> v) {
    string res = "";
    for (size_t i = 0; i < N; i++) {
        res += static_cast<char>('0' + v[i]);
    }
    return res;
}

template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ")";
}

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ", " + to_string(get<3>(p)) + ")";
}

void debug_out() { cerr << endl; }

template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define eb emplace_back
#define ld long double

struct Point { //   
    long long x = 0, y = 0;
    Point() {};
    Point(long long x, long long y) : x(x), y(y) {};
    Point operator +(const Point& a) const { //  
        return Point(x + a.x, y + a.y);
    }
    Point operator -(const Point& a) const { //  
        return Point(x - a.x, y - a.y);
    }
    Point operator -() const { //  
        return Point(-x, -y);
    }
    Point operator *(long long k) const { //    
        return Point(x * k, y * k);
    }
    Point operator /(long long k) const { //    
        return Point(x / k, y / k);
    }
    Point& operator +=(const Point& a) { //   
        return *this = *this + a;
    }
    Point& operator -=(const Point& a) { //   
        return *this = *this - a;
    }
    Point& operator *=(long long k) { //  
        return *this = *this * k;
    }
    Point& operator /=(long long k) { //  
        return *this = *this / k;
    }
    bool operator <(const Point& a) const {
        return y < a.y || (y == a.y && x < a.x);
    }
    bool operator >(const Point& a) const {
        return a < *this;
    }
    bool operator ==(const Point& a) const {
        return x == a.x && y == a.y;
    }
    bool operator <=(const Point& a) const {
        return !(*this > a);
    }
    bool operator >=(const Point& a) const {
        return !(*this < a);
    }
    bool operator !=(const Point& a) const {
        return !(*this == a);
    }
    long long len2() const { //   
        return x * x + y * y;
    }
    long long len() const { //  
        return (long long) (sqrt(x * x + y * y));
    }
    Point normal() const { // 
        return Point(-y, x);
    }
    Point unit() const { // 
        return *this / len();
    }
    Point& tounit() {
        return *this = *this / len();
    }
    Point symmetry(const Point& a) const { //    a
        return a + a - *this;
    }
    long double angle() const { //     Ox
        return atan2(y, x);
    }
};

istream &operator >>(istream& in, Point& a) {
    in >> a.x;
    in >> a.y;
    return in;
}

ostream &operator <<(ostream& out, Point& a) {
    out << a.x << " " << a.y;
    return out;
}

Point middle(const Point& a, const Point& b) { //  
    return (a + b) / 2;
}

Point min(const Point& a, const Point& b) {
    return (a < b ? a : b);
}

Point max(const Point& a, const Point& b) {
    return (a > b ? a : b);
}

long long operator *(const Point &a, const Point &b) {
    return a.x * b.y - a.y * b.x;
}

long long operator %(const Point &a, const Point &b) {
    return a.x * b.x + a.y * b.y;
}

long long dist(const Point &a, const Point &b) { //   
    return (a - b).len();
}

long long dist2(const Point &a, const Point &b) { //     
    return (a - b).len2();
}

bool in_triangle(const Point &a, const Point &b, const Point &c, const Point &p) { //     p  abc
	return abs((a - p) * (b - p)) + abs((b - p) * (c - p)) + abs((c - p) * (a - p)) == abs((a - b) * (c - b));
}

long long S(const Point& a, const Point& b, const Point& c) { //  
    return ((b - a) * (c - a)) / 2;
}

int id(const Point& a) { //  
    if (a.x == 0 && a.y == 0) return 1;
    if (a.x > 0 && a.y >= 0) return 1;
    if (a.x <= 0 && a.y > 0) return 2;
    if (a.x < 0 && a.y <= 0) return 3;
    return 4;
}

bool cmp(const Point& a, const Point& b) {
    if (id(a) != id(b)) return id(a) < id(b);
    if (a * b == 0) return a.len2() < b.len2();
    return a * b > 0;
}

bool cmp2(Point a, Point b, Point c) {
    a -= c;
    b -= c;
    if (id(a) != id(b)) return id(a) < id(b);
    if (a * b == 0) return a.len2() < b.len2();
    return a * b > 0;
}

struct line{
    long long a = 1, b = 0, c = 0;
    line() {};
    line(long long a, long long b, long long c) : a(a), b(b), c(c) {};
    line(Point A, Point B) {
        a = B.y - A.y;
        b = A.x - B.x;
        c = - (a * A.x + b * A.y);
    };
};

bool isonline(const line l, const Point p) { //   
    return l.a * p.x + l.b * p.y + l.c == 0;
}

bool same_sign_equal(long long a, long long b) {
    return (a >= 0 && b >= 0) || (a <= 0 && b <= 0);
}

bool inter(const Point& a, const Point& b, const Point& c, const Point& d) { //    ab  cd
    long long res1 = (b - a) * (c - a);
    long long res2 = (b - a) * (d - a);
    long long res3 = (d - c) * (a - c);
    long long res4 = (d - c) * (b - c);
    return !same_sign_equal(res1, res2) && !same_sign_equal(res3, res4);
}

vector<Point> obl(vector<Point> a) { //   
    int n = a.size();
    Point start = a[0];
    for (int i = 0; i < n; i++) start = min(start, a[i]);
    sort(a.begin(), a.end(), [&] (Point a, Point b) {
         return cmp2(a, b, start); });
    vector<Point> ch;
    for (int i = 0; i < n; i++) {
        while (ch.size() >= 2 && (ch.back() - ch[(int) ch.size() - 2]) * (a[i] - ch.back()) <= 0) {
            ch.pop_back();
        }
        ch.push_back(a[i]);
    }
    return ch;
}

struct Polygon{ // 
    int n;
    vector<Point> p; //  
    vector<Point> v; //       
    Polygon() {}
    Polygon(vector<Point>& a) {
        p = obl(a);
        n = p.size();
        for (int i = 1; i < n; i++) {
            v.push_back(p[i] - p[0]);
        }
    }
    Polygon operator+(const Polygon& a) const { //  
        vector<Point> v;
        int i = 0, j = 0;
        while (i < n || j < a.n) {
            if (j == a.n || (i < n && cmp(p[(i + 1) % n] - p[i], a.p[(j + 1) % a.n] - a.p[j]))) {
                v.push_back(p[(i + 1) % n] - p[i]);
                i++;
            }
            else {
                v.push_back(a.p[(j + 1) % a.n] - a.p[j]);
                j++;
            }
        }
        vector<Point> res;
        res.push_back(Point(0, 0));
        for (int i = 0; i < (int) v.size() - 1; i++) {
            res.push_back(Point(res.back().x + v[i].x, res.back().y + v[i].y));
        }
        const long long INF = 1e18;
        Point min_Point1 = Point(INF, INF);
        Point min_Point2 = Point(INF, INF);
        Point min_Point_res = Point(INF, INF);
        for (auto& c : p) {
            min_Point1 = min(min_Point1, c);
        }
        for (auto& c : a.p) {
            min_Point2 = min(min_Point2, c);
        }
        for (auto& c : res) {
            min_Point_res = min(min_Point_res, c);
        }
        Point delta(min_Point1.x + min_Point2.x - min_Point_res.x, min_Point1.y + min_Point2.y - min_Point_res.y);
        for (auto& c : res) {
            c.x += delta.x;
            c.y += delta.y;
        }
        return Polygon(res);
    }
    Polygon operator-(const Polygon& a) const { //  
        vector<Point> now = a.p;
        for (auto& c : now) {
            c.x *= -1;
            c.y *= -1;
        }
        return (*this) + Polygon(now);
    }
    bool is_inside(const Point &a) const { //     
        Point v1 = a - p[0], v2 = a - p.back();
        if (!same_sign_equal(v[0] * v1, v[0] * v.back()) || !same_sign_equal(v.back() * v2, v.back() * v[0])) {
            return false;
        }
        int ind2 = upper_bound(v.begin(), v.end(), v1, cmp) - v.begin();
        ind2++;
        ind2 = min(ind2, n - 1);
        int ind1 = ind2 - 1;
        return in_triangle(p[0], p[ind1], p[ind2], a);;
    }
    bool inside(const Point& a) const { //     
        Point to(a.x + 1e9 + 7, a.y + 1e9 + 9);
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (inter(p[i], p[(i + 1) % n], a, to)) {
                cnt++;
            }
        }
        return cnt % 2 == 1;
    }
    long long S() { // 
        Point beg(0, 0);
        long long ans = 0;
        for (int i = 0; i < n; i++) {
            Point v1 = p[i] - beg, v2 = p[(i + 1) % n] - beg;
            ans += (long long) (v1 * v2);
        }
        return abs(ans) / 2;
    }
};

bool XAXA(Point A, Point B, Point C, Point D) {
    if ((!same_sign_equal((B - A) * (C - A), (B - A) * (D - A))) && (!same_sign_equal((D - C) * (A - C), (D - C) * (B - C)))) {
        return true;
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<Point> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<Point> b = obl(a);
    //for (auto x : b) cout << x << " "; cout << endl;
    vector<vector<bool>> used(n, vector<bool> (n, 0));
    int m = b.size();
    vector<pii> d;
    vector<pii> tmp;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            tmp.pb({i, j});
        }
    }
    int id = 0;
    int tr = m - 2 + (n - m) * 2;
    int c = m + (3 * tr - m) / 2;
    auto check = [&] (int x, int y) {
        if (used[x][y]) return false;
        for (auto el : d) {
            int x2 = el.fi, y2 = el.se;
            if (x == x2 || y == y2 || y == x2 || x == y2) continue;
            if (XAXA(a[x], a[y], a[x2], a[y2])) return false;
        }
        return true;
    };
    auto add = [&] () {
        while (true) {
            if (check(tmp[id].fi, tmp[id].se)) {
                int x = tmp[id].fi, y = tmp[id].se;
                cout << x + 1 << " " << y + 1 << endl;
                d.pb({x, y});
                used[x][y] = true;
                used[y][x] = true;
                break;
            }
            id++;
        }
    };
    auto add2 = [&] (int x, int y) {
        d.pb({x, y});
        used[x][y] = true;
        used[y][x] = true;
    };
    if (c % 2 == 1) {
        cout << 1 << endl;
        while (true) {
            add();
            int x, y;
            cin >> x >> y;
            if (x == 0 && y == 0) {
                return 0;
            }
            add2(x - 1, y - 1);
        }
    }
    else {
        cout << 2 << endl;
        while (true) {
            int x, y;
            cin >> x >> y;
            if (x == 0 && y == 0) {
                return 0;
            }
            add2(x - 1, y - 1);
            add();
        }
    }
 }
