#define _CRT_SECURE_NO_WARNINGS
#define MANSON
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <random>
#include <chrono>
#include <string>
#include <set>
using namespace std;
#ifdef MANSON
#define BUGO(x) cerr << #x << " = " << (x) << '\n';
#define BUGOARR(a) cerr << #a << ": "; for (auto i: a) cerr << i << ' '; cerr << '\n';
#else
#define BUGO(x)
#define BUGOARR(a)
#endif
using llong = long long;
using uint = unsigned int;
using ullong = unsigned long long;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline int rnd(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
inline llong rndll(llong l, llong r) { return uniform_int_distribution<llong>(l, r)(rng); }

vector<pair<int, int>> nei[1005][1005];
char a[1005][1005];
char ans[1005][1005];
bool bad[1005][1005];
int n, m; int ddd = 0;

pair<pair<int, int>, pair<int, int>> Open(int i, int j)
{
    if (i && a[i - 1][j] == a[i][j]) --i;
    if (j && a[i][j - 1] == a[i][j]) --j;
    int I = i + 1, J = j;
    int x, y, X, Y;
    if (i < n && a[i][j] == a[I][J])
    {
        x = i, y = j, X = I, Y = J;
        if ('A' <= a[i][j] && a[i][j] <= 'Z')
            ++y, ++Y;
        else
            --y, --Y;
    }
    else
    {
        I = i, J = j + 1;
        x = i, y = j, X = I, Y = J;
        if ('A' <= a[i][j] && a[i][j] <= 'Z')
            ++x, ++X;
        else
            --x, --X;
    }
    pair<int, int> p = { x, y }, q = { X, Y };
    if (p > q) swap(p, q);
    return make_pair(p, q);
}
void Unfold(int i, int j, bool isbad)
{
    if (!isbad) ++ddd;
    if (i && a[i - 1][j] == a[i][j]) --i;
    if (j && a[i][j - 1] == a[i][j]) --j;
    int I = i, J = j;
    if (i + 1 < n && a[i + 1][j] == a[i][j]) ++I;
    else ++J;
    set<char> poss;
    for (char tch = '0'; tch <= '9'; ++tch)
        poss.insert(tch);
    int dx[] = {-1, 1, 0, 0};
    int dy[] = {0, 0, -1, 1};
    auto temp = Open(i, j);
    auto p = temp.first, q = temp.second;
    for (int dir = 0; dir < 4; ++dir)
    {
        int x = i + dx[dir];
        int y = j + dy[dir];
        if (x >= 0 && y >= 0 && x < n && y < m)
            poss.erase(ans[x][y]);
        x = I + dx[dir];
        y = J + dy[dir];
        if (x >= 0 && y >= 0 && x < n && y < m)
            poss.erase(ans[x][y]);
        if (!isbad)
        {
            x = q.first + dx[dir];
            y = q.second + dy[dir];
            if (x >= 0 && y >= 0 && x < n && y < m)
                poss.erase(ans[x][y]);
            x = p.first + dx[dir];
            y = p.second + dy[dir];
            if (x >= 0 && y >= 0 && x < n && y < m)
                poss.erase(ans[x][y]);
        }
    }
    ans[i][j] = ans[I][J] = *poss.begin();
    if (!isbad)
        ans[p.first][p.second] = ans[q.first][q.second] = *poss.begin();
}
void DFS(int i, int j, bool now)
{
    Unfold(i, j, !now);
    for (pair<int, int> to : nei[i][j]) {
        if (ans[to.first][to.second] == '?')
            DFS(to.first, to.second, !now);
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            ans[i][j] = '?';
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            cin >> a[i][j];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            if (bad[i][j] || a[i][j] == '.') continue;
            auto temp = Open(i, j);
            auto p = temp.first, q = temp.second;
            bool ok = true;
            for (auto tch : { p, q })
                if (tch.first < 0 || tch.first >= n || tch.second < 0 || tch.second >= m)
                    ok = false;
            if (ok) continue;
            bad[i][j] = true;
            if (i && a[i - 1][j] == a[i][j])
                bad[i - 1][j] = true;
            if (j && a[i][j - 1] == a[i][j])
                bad[i][j - 1] = true;
        }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (a[i][j] != '.') {
                    if ((i + 1 < n && a[i + 1][j] == a[i][j]) ||
                        (j + 1 < m && a[i][j + 1] == a[i][j]))
                    {
                        auto p = Open(i, j);
                        for (int x = i - 3; x <= i + 3; ++x)
                            for (int y = j - 3; y <= j + 3; ++y)
                                if (x >= 0 && x < n && y >= 0 && y < m && a[x][y] != '.' &&
                                    !bad[x][y])
                                {
                                    if ((x + 1 < n && a[x + 1][y] == a[x][y]) ||
                                        (y + 1 < m && a[x][y + 1] == a[x][y]))
                                    {
                                        if (x == i && y == j) continue;
                                        if (make_pair(i, j) > make_pair(x, y)) continue;
                                        auto q = Open(x, y);
                                        if (p.first == q.first || p.first == q.second ||
                                            p.second == q.first || p.second == q.second) {
                                            nei[i][j].push_back({ x, y });
                                            nei[x][y].push_back({ i, j });
                                        }
                                    }
                                }
                    }
            }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if ((i + 1 < n && a[i + 1][j] == a[i][j]) ||
                (j + 1 < m && a[i][j + 1] == a[i][j]))
            if (ans[i][j] == '?' && a[i][j] != '.')
            {
                if (bad[i][j])
                    Unfold(i, j, true);
                else if (nei[i][j].size() == 0)
                    Unfold(i, j, false);
                else if (nei[i][j].size() == 1)
                    DFS(i, j, true);
            }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (!bad[i][j] && ans[i][j] == '?' && a[i][j] != '.')
                DFS(i, j, true);
    cout << ddd << '\n';
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j)
            cout << (ans[i][j] == '?' ? '.' : ans[i][j]);
        cout << '\n';
    }
}
