#pragma GCC optimize("O2,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2")
#include<bits/stdc++.h>
#define all(x) begin(x), end(x)
using namespace std;
using ll = long long;
const int maxn = 1010, mod = 998244353;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#ifndef ATCODER_MAXFLOW_HPP
#define ATCODER_MAXFLOW_HPP 1

#include <algorithm>
#include <cassert>
#include <limits>
#include <queue>
#include <vector>

#ifndef ATCODER_INTERNAL_QUEUE_HPP
#define ATCODER_INTERNAL_QUEUE_HPP 1

#include <vector>

namespace atcoder {

namespace internal {

template <class T> struct simple_queue {
    std::vector<T> payload;
    int pos = 0;
    void reserve(int n) { payload.reserve(n); }
    int size() const { return int(payload.size()) - pos; }
    bool empty() const { return pos == int(payload.size()); }
    void push(const T& t) { payload.push_back(t); }
    T& front() { return payload[pos]; }
    void clear() {
        payload.clear();
        pos = 0;
    }
    void pop() { pos++; }
};

}  // namespace internal

}  // namespace atcoder

#endif  // ATCODER_INTERNAL_QUEUE_HPP


namespace atcoder {

template <class Cap> struct mf_graph {
  public:
    mf_graph() : _n(0) {}
    mf_graph(int n) : _n(n), g(n) {}

    int add_edge(int from, int to, Cap cap) {
        assert(0 <= from && from < _n);
        assert(0 <= to && to < _n);
        assert(0 <= cap);
        int m = int(pos.size());
        pos.push_back({from, int(g[from].size())});
        g[from].push_back(_edge{to, int(g[to].size()), cap});
        g[to].push_back(_edge{from, int(g[from].size()) - 1, 0});
        return m;
    }

    struct edge {
        int from, to;
        Cap cap, flow;
    };

    edge get_edge(int i) {
        int m = int(pos.size());
        assert(0 <= i && i < m);
        auto _e = g[pos[i].first][pos[i].second];
        auto _re = g[_e.to][_e.rev];
        return edge{pos[i].first, _e.to, _e.cap + _re.cap, _re.cap};
    }
    std::vector<edge> edges() {
        int m = int(pos.size());
        std::vector<edge> result;
        for (int i = 0; i < m; i++) {
            result.push_back(get_edge(i));
        }
        return result;
    }
    void change_edge(int i, Cap new_cap, Cap new_flow) {
        int m = int(pos.size());
        assert(0 <= i && i < m);
        assert(0 <= new_flow && new_flow <= new_cap);
        auto& _e = g[pos[i].first][pos[i].second];
        auto& _re = g[_e.to][_e.rev];
        _e.cap = new_cap - new_flow;
        _re.cap = new_flow;
    }

    Cap flow(int s, int t) {
        return flow(s, t, std::numeric_limits<Cap>::max());
    }
    Cap flow(int s, int t, Cap flow_limit) {
        assert(0 <= s && s < _n);
        assert(0 <= t && t < _n);

        std::vector<int> level(_n), iter(_n);
        internal::simple_queue<int> que;

        auto bfs = [&]() {
            std::fill(level.begin(), level.end(), -1);
            level[s] = 0;
            que.clear();
            que.push(s);
            while (!que.empty()) {
                int v = que.front();
                que.pop();
                for (auto e : g[v]) {
                    if (e.cap == 0 || level[e.to] >= 0) continue;
                    level[e.to] = level[v] + 1;
                    if (e.to == t) return;
                    que.push(e.to);
                }
            }
        };
        auto dfs = [&](auto self, int v, Cap up) {
            if (v == s) return up;
            Cap res = 0;
            int level_v = level[v];
            for (int& i = iter[v]; i < int(g[v].size()); i++) {
                _edge& e = g[v][i];
                if (level_v <= level[e.to] || g[e.to][e.rev].cap == 0) continue;
                Cap d =
                    self(self, e.to, std::min(up - res, g[e.to][e.rev].cap));
                if (d <= 0) continue;
                g[v][i].cap += d;
                g[e.to][e.rev].cap -= d;
                res += d;
                if (res == up) break;
            }
            return res;
        };

        Cap flow = 0;
        while (flow < flow_limit) {
            bfs();
            if (level[t] == -1) break;
            std::fill(iter.begin(), iter.end(), 0);
            while (flow < flow_limit) {
                Cap f = dfs(dfs, t, flow_limit - flow);
                if (!f) break;
                flow += f;
            }
        }
        return flow;
    }

    std::vector<bool> min_cut(int s) {
        std::vector<bool> visited(_n);
        internal::simple_queue<int> que;
        que.push(s);
        while (!que.empty()) {
            int p = que.front();
            que.pop();
            visited[p] = true;
            for (auto e : g[p]) {
                if (e.cap && !visited[e.to]) {
                    visited[e.to] = true;
                    que.push(e.to);
                }
            }
        }
        return visited;
    }

  private:
    int _n;
    struct _edge {
        int to, rev;
        Cap cap;
    };
    std::vector<std::pair<int, int>> pos;
    std::vector<std::vector<_edge>> g;
};

}  // namespace atcoder

#endif  // ATCODER_MAXFLOW_HPP

char mat[maxn][maxn];
int n, m, v[maxn][maxn], h[maxn][maxn];
bool lower(char c) {
    return 'a' <= c && c <= 'z';
}
int f(int a, int b) {
    a/=2, b/=2;
    return (a&1)*2 + (b&1);
}
int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> m;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            cin >> mat[i][j];
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++) {
            if(mat[i][j] == '.') continue;
            if(mat[i][j] == mat[i+1][j]) {
                if(lower(mat[i][j])) {
                    if(j) v[i][j-1] = -1;
                } else v[i][j+1] = 1;
            }
            if(mat[i][j+1] == mat[i][j]) {
                if(lower(mat[i][j])) {
                    if(i) h[i-1][j] = -1;
                } else h[i+1][j] = 1;
            }
        }
    atcoder::mf_graph<int> mf(2 + n*m);
    auto add_edge = [&](int i, int j, int daslj) {
        if(((j%m) + (j/m))&1) swap(i, j);
        //cout << i/m << " " << i%m << " -> " << j/m << " " << j%m << endl;
        mf.add_edge(2+i, 2+j, 1);
    };
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++) {
            if((i+j)%2) mf.add_edge(0, 2+i*m+j, 1);
            else mf.add_edge(2+i*m+j, 1, 1);
            if(i+1 < n && v[i][j]) {
                add_edge(i*m + j, i*m + j + m, 1);
                //cout << i << " " << j << " " << i+1 << " " << j << endl;
            }
            if(j+1 < m && h[i][j]) {
                add_edge(i*m + j, i*m+j+1, 1);
                //cout << i << " " << j << " " << i << " " << j+1 << endl;
            }
        }
    auto t = mf.flow(0, 1);
    cout << t << endl;
    //for(int i = 0; i < n; i++, cout << endl) for(int j = 0; j < m; j++) cout << h[i][j] << " ";
    //for(int i = 0; i < n; i++, cout << endl) for(int j = 0; j < m; j++) cout << v[i][j] << " ";
    memset(mat, '.', sizeof mat);
    for(auto i : mf.edges()) if(i.flow && i.from != 0 && i.to != 1) {
            i.from -= 2, i.to -= 2;
            int a = i.from/m, b = i.from%m, x = i.to/m, y = i.to%m;
            if(a == x) {
                if(b > y) swap(b, y);
                if(h[a][b] == 1) {
                    //cout << a-1 << " _ " << b << " " << ((a-1)%2)*2 + (b%2) << endl;
                    mat[a][b] = mat[a][y] = mat[a-1][b] = mat[a-1][y] = '0' + f(a-1, b);
                } else {
                    //cout << a << " _ " << b << endl;
                    mat[a][b] = mat[a][y] = mat[a+1][b] = mat[a+1][y] = '0' + f(a, b);
                }
            } else {
                if(a > x) swap(a, x);
                if(h[a][b] == 1) {
                    //cout << a << " _ " << b-1 << " " << a%2 << " " << (b-1)%2 << endl;
                    mat[a][b] = mat[x][b] = mat[a][b-1] = mat[x][b-1] = '0' + f(a, b);
                } else {
                    mat[a][b] = mat[x][b] = mat[a][b+1] = mat[x][b+1] = '0' + f(a, b);
                }
            }
    }
    for(int i = 0; i < n; i++, cout << '\n') for(int j = 0; j < m; j++) cout << mat[i][j];
}
