#include <bits/stdc++.h>
using namespace std;

//#define int long long

void dfs_find(int32_t v, bool* visited, std::vector<int32_t>* graph,
              int32_t& end) {
    bool has_children = false;
    visited[v] = true;
    for(int32_t i = 0; i < graph[v].size(); i++) {
        if(!visited[graph[v][i]]) {
            dfs_find(graph[v][i], visited, graph, end);
            has_children = true;
        }
    }
    if(!has_children)
        end = v;
}

void dfs_mark(int32_t v, bool* visited, std::vector<int32_t>* graph,
              bool take, std::set<int32_t>& res) {
    if(take)
        res.insert(v);
    visited[v] = true;
    for(int32_t i = 0; i < graph[v].size(); i++) {
        if(!visited[graph[v][i]]) {
            dfs_mark(graph[v][i], visited, graph, !take, res);
        }
    }
}

void dfs_final(int32_t v, bool* visited, std::vector<int32_t>* graph,
               std::map<int32_t, int32_t>& compressed) {
    visited[v] = true;
    std::set<int32_t> neighbors;
    for(int32_t i = 0; i < graph[v].size(); i++) {
        if(visited[graph[v][i]]) {
            neighbors.insert(compressed[graph[v][i]]);
        }
    }

    for(int32_t i = 0; i <= 9; i++) {
        if(neighbors.find(i) == neighbors.end()) {
            compressed[v] = i;
            break;
        }
    }

    for(int32_t i = 0; i < graph[v].size(); i++) {
        if(!visited[graph[v][i]]) {
            dfs_final(graph[v][i], visited, graph, compressed);
        }
    }
}

signed main() {
    int32_t n,  m;
    std::cin >> n >> m;

    std::string* field = new std::string[n];
    for(int32_t i = 0 ; i < n ; i++) {
        std::cin >> field[i];
    }

    int32_t** status = new int32_t*[n];
    bool** visited = new bool*[n];
    for(int32_t i = 0 ; i < n ; i++) {
        visited[i] = new bool[m];
        status[i] = new int32_t[m];
        for(int32_t j = 0; j < m; j++) {
            visited[i][j] = false;
            status[i][j] = -1;
        }
    }

    int32_t last = 0;
    bool* vertical = new bool[n * m];
    for(int32_t i = 0; i < n * m; i++)
        vertical[i] = false;
    for(int32_t i = 0; i < n; i++) {
        for(int32_t j = 0; j < m; j++) {
            if(field[i][j] == '.' || visited[i][j])
                continue;
            visited[i][j] = true;
            status[i][j] = last;
            if(i < n - 1 && field[i + 1][j] == field[i][j]) {
                status[i + 1][j] = status[i][j];
                vertical[last] = true;
                visited[i + 1][j] = true;
            } else {
                status[i][j + 1] = status[i][j];
                visited[i][j + 1] = true;
            }
            last++;
        }
    }

    std::set<int32_t> blocked;
    for(int32_t i = 0; i < n; i++)
        for(int32_t j = 0 ; j < m; j++) {
            if(!visited[i][j])
                continue;

            bool res = true;
            if(field[i][j] >= 'A' && field[i][j] <= 'Z') {
                if(vertical[status[i][j]]) {
                    if(j == m - 1) {
                        res = false;
                    } else if(field[i][j + 1] != '.')
                        res = false;
                }  else {
                    if(i == n - 1) {
                        res = false;
                    } else if(field[i + 1][j] != '.')
                        res = false;
                }
            } else {
                if(vertical[status[i][j]]) {
                    if(j == 0) {
                        res = false;
                    } else if(field[i][j - 1] != '.')
                        res = false;
                }  else {
                    if(i == 0) {
                        res = false;
                    } else if(field[i - 1][j] != '.')
                        res = false;
                }
            }
        if(!res)
            blocked.insert(status[i][j]);
    }

    std::vector<int32_t>** next = new std::vector<int32_t>*[n];
    for(int32_t i = 0; i < n; i++) {
        next[i] = new std::vector<int32_t>[m];
    }

    for(int32_t i = 0; i < n; i++) {
        for (int32_t j = 0; j < m; j++) {
            if(field[i][j] == '.' || blocked.find(status[i][j]) != blocked.end())
                continue;

            if(vertical[status[i][j]]) {
                if (field[i][j] >= 'A' && field[i][j] <= 'Z')
                    next[i][j + 1].push_back(status[i][j]);
                else
                    next[i][j - 1].push_back(status[i][j]);
            } else {
                if (field[i][j] >= 'A' && field[i][j] <= 'Z')
                    next[i + 1][j].push_back(status[i][j]);
                else
                    next[i - 1][j].push_back(status[i][j]);
            }
        }
    }

    std::vector<int32_t>* graph = new std::vector<int32_t>[n * m];

    for(int32_t i = 0; i < n; i++) {
        for (int32_t j = 0; j < m; j++) {
            for(int32_t k = 0; k < next[i][j].size(); k++)
                for(int32_t p = k + 1; p < next[i][j].size(); p++) {
                    graph[next[i][j][k]].push_back(next[i][j][p]);
                    graph[next[i][j][p]].push_back(next[i][j][k]);
            }
        }
    }

    bool* visited2 = new bool[n * m];
    for(int32_t i = 0; i < n * m; i++)
        visited2[i] = false;
    std::vector<int32_t> ends;
    for(int32_t i = 0; i < last; i++) {
        if(visited2[i])
            continue;
        if(blocked.find(i) != blocked.end())
            continue;
        int32_t end = -1;
        dfs_find(i, visited2, graph, end);

        ends.push_back(end);
    }

    for(int32_t i = 0; i < n * m; i++)
        visited2[i] = false;
    std::set<int32_t> final_inflated;
    for(int32_t i = 0 ; i< ends.size(); i++) {
        dfs_mark(ends[i], visited2, graph, true, final_inflated);
        for(int32_t j = 0; j < graph[ends[i]].size(); j++)
            if(final_inflated.find(graph[ends[i]][j]) != final_inflated.end()) {
                final_inflated.erase(ends[i]);
                break;
            }
    }

    std::cout << final_inflated.size() << "\n";

    int32_t** final_status = new int32_t*[n];
    for(int32_t i = 0 ; i < n; i++) {
        final_status[i] = new int32_t[m];
        for(int32_t j = 0 ; j < m; j++)
            final_status[i][j] = field[i][j] == '.' ? -1 : status[i][j];
    }
    for(int32_t i = 0 ; i < n; i++) {
        for(int32_t j = 0; j < m; j++) {
            if(final_inflated.find(status[i][j]) != final_inflated.end()) {
                if(vertical[status[i][j]]) {
                    if (field[i][j] >= 'A' && field[i][j] <= 'Z')
                        final_status[i][j + 1] = status[i][j];
                    else
                        final_status[i][j - 1] = status[i][j];
                } else {
                    if (field[i][j] >= 'A' && field[i][j] <= 'Z')
                        final_status[i + 1][j] = status[i][j];
                    else
                        final_status[i - 1][j] = status[i][j];
                }
            }
        }
    }

    std::vector<int32_t>* graph2 = new std::vector<int32_t>[n * m];
    for(int32_t i = 0; i < n; i++) {
        for(int32_t j = 0; j < m; j++) {
            if(final_status[i][j] == -1)
                continue;
            if(i > 0 && final_status[i - 1][j] != -1 &&
               final_status[i - 1][j] != final_status[i][j]) {
                graph2[final_status[i][j]].push_back(final_status[i - 1][j]);
                //graph2[final_status[i - 1][j]].push_back(final_status[i][j]);
            }
            if(i < n - 1 && final_status[i + 1][j] != -1 &&
               final_status[i + 1][j] != final_status[i][j]) {
                graph2[final_status[i][j]].push_back(final_status[i + 1][j]);
                //graph2[final_status[i + 1][j]].push_back(final_status[i][j]);
            }
            if(j < m - 1 && final_status[i][j + 1] != -1 &&
               final_status[i][j + 1] != final_status[i][j]) {
                graph2[final_status[i][j]].push_back(final_status[i][j + 1]);
                //graph2[final_status[i][j + 1]].push_back(final_status[i][j]);
            }
            if(j > 0 && final_status[i][j - 1] != -1 &&
               final_status[i][j - 1] != final_status[i][j]) {
                graph2[final_status[i][j]].push_back(final_status[i][j - 1]);
                //graph2[final_status[i][j - 1]].push_back(final_status[i][j]);
            }
        }
    }

    for(int32_t i = 0; i < last; i++) {
        std::sort(graph2[i].begin(), graph2[i].end());
        graph2[i].resize(std::unique(graph2[i].begin(), graph2[i].end()) - graph2[i].begin());
    }

    for(int32_t i = 0; i < n * m; i++)
        visited2[i] = false;

    std::map<int32_t, int32_t> compressed;
    for(int32_t i = 0; i < last; i++)
        if(!visited2[i])
            dfs_final(i, visited2, graph2, compressed);

    for(int32_t i = 0; i < n; i++){
        for(int32_t j = 0; j < m ;j++) {
            std::cout << (final_status[i][j] == -1 ? '.' : (char)('0' + compressed[final_status[i][j]]));
        }
        std::cout << "\n";
    }
    return 0;
}






//1,414213562














